/**
 * 3DQ[GW SphereEnginepbP[WłB
 *
 * @package_overview
 * @package 	SphereEngine
 * @caption		SphereEnginepbP[W
 * @license 	GfBbg~bV̒쌠KChCɏ
 * @author		Rectangle
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 * @url 		&lt;a href="http://www.rectangle.jp/"&gt;l\tgT[N Rectangle&lt;/a&gt;
 */

/**
 * SphereEngineW֐Lqt@CłB
 *
 * @file_overview
 * @license 	GfBbg~bV̒쌠KChCɏ
 * @author		Rectangle
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 * @url 		&lt;a href="http://www.rectangle.jp/"&gt;l\tgT[N Rectangle&lt;/a&gt;
 */

/**
 * iPʂ̓WA[rad]j̐߂܂B
 *
 * @param		float	a	
 * @return		float	l
 * @caption		߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float sin(float a);

/**
 * iPʂ̓WA[rad]j̗]߂܂B
 *
 * @param		float	a	
 * @return		float	]l
 * @caption		]߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float cos(float a);

/**
 * iPʂ̓WA[rad]j̐ڂ߂܂B
 *
 * @param		float	a	
 * @return		float	ڒl
 * @caption		ڂ߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float tan(float a);

/**
 * i͈͂[-1,1]Ƃ邱Ɓj̋tiPʂ̓WA[rad]j߂܂B
 *
 * @param		float	a	
 * @return		float	tl
 * @caption		t߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float asin(float a);

/**
 * i͈͂[-1,1]Ƃ邱Ɓj̋t]iPʂ̓WA[rad]j߂܂B
 *
 * @param		float	a	
 * @return		float	t]l
 * @caption		t]߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float acos(float a);

/**
 * ̋tځiPʂ̓WA[rad]j߂܂B
 *
 * @param		float	a	
 * @return		float	tڒl
 * @caption		tڂ߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float atan(float a);

/**
 * y/x̋tځiPʂ̓WA[rad]j߂܂B
 *
 * <p>
 * ix=0̏ꍇx,y̐ɂی̈Ⴂl܂Bj
 * </p>
 *
 * @param		float	y	y/x̕q
 * @param		float	x	y/x̕
 * @return		float	tڒl
 * @caption		y/x̋tڂ߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float atan2(float y, float x);

/**
 * ̐Βl߂܂B
 *
 * @param		float	x	
 * @return		float	Βl
 * @caption		Βl߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float fabs(float x);

/**
 * i͈͂x>0Ƃ邱Ɓj̎Rΐ߂܂Biej
 *
 * @param		float	x	
 * @return		float	Rΐ̒l
 * @caption		Rΐ߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float log(float x);

/**
 * i͈͂x>0Ƃ邱Ɓjpΐ߂܂Bi10j
 *
 * @param		float	x	
 * @return		float	pΐ̒l
 * @caption		pΐ߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float log10(float x);

/**
 * ׂ߂܂Bi̎w)
 *
 * @param		float	x	
 * @param		float	p	w
 * @return		float	xp̒l
 * @caption		ׂ߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float pow(float x, float p);

/**
 * w֐߂܂Bie̎w)
 *
 * @param		float	x	w
 * @return		float	ex̒l
 * @caption		w֐߂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall float exp(float x);

/**
 * ̃oCgԂ܂B
 *
 * @param		string	str	Ώە
 * @return		int	̃oCg
 * @caption		̃oCgԂ
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall int string_length(string str);

/**
 * Ŏw肳ꂽ̐擪Ŏw肳ꂽoCg̕Ԃ܂B
 *
 * <p>
 * Spɑ΂ĎgpꍇAɓ삵Ȃꍇ܂B
 * </p>
 *
 * @param		string	str	Ώە
 * @param		int		n	擪̃oCg
 * @return		string	擪Ŏw肳ꂽoCg܂ł̕
 * @caption		̐擪w肳ꂽoCg܂łԂ
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall string string_head(string str, int n);

/**
 * Ŏw肳ꂽ̖Ŏw肳ꂽoCg̕Ԃ܂B
 *
 * <p>
 * Spɑ΂ĎgpꍇAɓ삵Ȃꍇ܂B
 * </p>
 *
 * @param		string	str	Ώە
 * @param		int		n	̃oCg
 * @return		string	Ŏw肳ꂽoCg܂ł̕
 * @caption		̖w肳ꂽoCg܂łԂ
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall string string_tail(string str, int n);

/**
 * @TODO message_box֐̐͂܂܂
 *
 * @param		string	title	i@TODO sj
 * @param		string	msg	i@TODO sj
 * @return		int	߂li@TODO sj
 * @caption		LvV͂܂܂i@TODOj
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall int message_box(string title, string msg);

/**
 * R\[Ɏw肵\܂B
 *
 * @param		string	msg	\镶
 * @return		int	߂li@TODO sj
 * @caption		R\[Ɏw肵\
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall int print_string(string msg);

/**
 * R\[ɕ͂A̕擾܂B
 *
 * @return		string	R\[͂ꂽ
 * @caption		R\[當͂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
systemcall string input_string();

/** @const	int	NULL	[NULLlF-1őp */
const int NULL = 1;

/** @const	int	TRUE	[TRUElF1őp */
const int TRUE = 1;

/** @const	int	FALSE	[FALSElF0őp */
const int FALSE = 0;

/** @const	int	FRAME	1b̃XNvgs񐔁i60Frame/secj */
const int FRAME = 60;

/** @const	int MAX_COUNTER_NUM	JE^̍ő吔 */
const int MAX_COUNTER_NUM = 64;

/** @var	int	__system_counter	JE^lێz */
int __system_counter[MAX_COUNTER_NUM];

/** @var	int	__system_thread_id	NĂJE^ZpXbhIDiNĂȂꍇNULLj */
int __system_thread_id = NULL;

/**
 * VXeɏԂ܂i1t[҂܂j
 *
 * @return		int	G[R[hi퓮쎞TRUEj
 * @caption		VXeɏԂi1t[҂j
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
function int system()
{
	return __system_interrupt__(1, "wait");
}

/**
 * Ŏw肵b҂܂B
 *
 * @param		float	timer	҂
 * @return		int	G[R[hi퓮쎞TRUEj
 * @caption		w肵b҂
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
function int wait_time(float timer)
{
	return __system_interrupt__((int)(timer*60), "wait");
	/* : 60t[łOŏĂ(FRAMElQƂĂȂ)vH */
}

/**
 * w肵֐păXbh𐶐܂B
 *
 * @param		valiable	new_thread_label	VXbhƂėp֐
 * @param		int	thread_arg	֐ɗ^
 * @return		int	XbhID
 * @caption		Xbh𐶐
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
function int create_thread(valiable new_thread_label, int thread_arg)
{
	int thread_id = __system_interrupt__(new_thread_label, thread_arg, "create_thread");
	return (thread_id);
	//return __system_interrupt__(new_thread_label, thread_arg, "create_thread");
}

/**
 * ݎs̃XbhIDԂ܂B
 *
 * @return		int	XbhID
 * @caption		ݎs̃XbhIDԂ
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
function int get_thread_id()
{
	return __system_interrupt__("get_thread_id");
}

/**
 * Ɏw肵XbhID̃XbhI܂B
 *
 * <p>
 * gIł܂B
 * </p>
 *
 * @param		int	thread_id	XbhID
 * @return		int	G[R[hi퓮쎞TRUEAُ펞FALSEj
 * @caption		Ɏw肵XbhI
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 */
function int exit_thread(int thread_id)
{
	return __system_interrupt__(thread_id, "exit_thread");
}

/**
 * g̃XbhI܂B
 *
 * @return		int	G[R[hi퓮쎞TRUEAُ펞FALSEj
 * @caption		g̃XbhI
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 * @see			function int exit_thread(int thread_id);
 * @see			function int get_thread_id();
 */
function int exit()
{
	return exit_thread(get_thread_id());
}

/**
 * w肵JE^ID̃JE^AJE^l擾܂B
 *
 * @param		int	counter_id	JE^ID
 * @return		int	JE^l
 * @caption		JE^l擾
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 * @see			int __system_counter[MAX_COUNTER_NUM];
 */
function int get_counter(int counter_id)
{
	return __system_counter[counter_id];
}

/**
 * w肵JE^ID̃JE^ɁAJE^lݒ肵܂B
 *
 * @param		int	counter_id	JE^ID
 * @param		int	count	JE^l
 * @return		int	JE^l
 * @caption		JE^l̐ݒ
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 * @see			int __system_counter[MAX_COUNTER_NUM];
 */
function int set_counter(int counter_id, int count)
{
	return __system_counter[counter_id]=count;
}

/**
 * w肵JE^ID̃JE^̓Jn܂B
 *
 * @param		int	counter_id	JE^ID(0MAX_COUNTER_NUM-1܂ŁB)
 * @return		int	G[R[hi퓮쎞TRUEAُ펞FALSEj
 * @caption		JE^l̃JEgJn
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 * @see			function int create_thread(valiable new_thread_label, int thread_arg);
 * @see			function int thread_counter(int arg);
 * @see			function int set_counter(int counter_id, int count);
 * @see			int __system_thread_id;
 */
function int start_counter(int counter_id)
{
	if (counter_id<0 || MAX_COUNTER_NUM<=counter_id) return FALSE;	//JE^ID͈̔̓`FbN
	if (__system_thread_id<0) {										//JE^ZXbhNĂȂꍇ
		__system_thread_id=create_thread(thread_counter, 0);		//JE^ZXbhN
	}
	set_counter(counter_id, 1);
	return TRUE;
}

/**
 * JE^ZXbhp֐iǑĂяo֎~j
 *
 * @param		int	arg	iȂj
 * @return		int	߂liȂj
 * @caption		JE^ZXbhp֐iǑĂяo֎~j
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5, SpE4.0
 * @see			function int system();
 * @see			int __system_counter[MAX_COUNTER_NUM];
 */
function int thread_counter(int arg)
{
	int i=0;
	while (TRUE) {							//[v
		system();
		for (i=0;i<MAX_COUNTER_NUM;i++) {
			if (__system_counter[i]) __system_counter[i]++;	//JE^ɒlĂCNg
		}
	}
}
